---
feature_story: FS_36_17_84_44
feature_title: check_env script
feature_status: TODO
---

The script is supposed to provide single place to perform multi-level verification.

This script may overlap with functions from FS_85_33_46_53 `bootstrap_env`.

See also FS_86_73_43_45 server control scripts.

It can start with checking:
*   Python version
*   `venv` existence
*   `argrelay` package existence

Then it jumps into checks implemented in Python (for testability) to verify:
*   whether it is run under FS_58_61_77_69 `dev_shell`
*   whether `PATH` env var reaches client and server binaries
*   whether completion is configured in shell
*   config locations used
*   any useful missing (or useless existing) settings in `~/.inputrc`
*   server availability
*   server version and compatibility
*   prints server instance id and whatever we can query to verify its state
*   print plugin list (serialized DAG) with types and activation status
*   any useful `readline` settings set or not
*   FS_57_36_37_48 (multiple clients) show all registered clients
*   show all registered commands (FS_57_36_37_48 per client)
*   print the same line info what `@/exe/dev_shell.bash` prints about version, conf, URL, etc.

What else?

```
# TODO: Connect to server to get:
#       server instance id (UUID),
#       argrelay framework server version,
#       server start time,
#       server setup version,
#       server setup commit id,
#       etc.

# TODO: Check if server is local.
#       Do not check via hostname.
#       Simply check netstat against port number to select pid.
#       Check if pid file exists.
#       Check if pid in pid file matches pid from netstat.
#       Verify if localhost:server_port_number succeeds with the same server instance id.

# TODO: additionally:
#       show latest server log.
```
